//import unification.Unification;
import java.util.*;
import java.util.Map.Entry;

import unification.Unification;
import clauseForm.ClauseForm;
//import expression.Expression;
import nabors.RuleA;
import nabors.RuleB;
import nabors.MainStr;
import nabors.Skleyka;

public class Main {
	

	Set<Entry<Double, Set<Entry<String, Entry<String, Entry<int[], HashSet<String>>>>>>> mSet;

	Unification uni = new Unification();
	ClauseForm cf = new ClauseForm(true);
	RuleA ra = new RuleA();		
	RuleB rb = new RuleB();
	Skleyka skl = new Skleyka();
	MainStr ms = new MainStr();

	
	public static void main(String[] args) {

		Main mn = new Main();
		int nextnumber;	
		
		//String s = "∃x,y[R(a,x)∨¬R(y,b)]"; 					// ex.0
		//String s = "∃x[R(a,x)∨¬R(x,b)]"; 					// ex.1
		//String s = "∃x[[P(x)∨¬P(a)]∧[P(x)∨¬P(b)]]"; 		// ex.2
		String s = "∃x,y[[R(a,x)∨¬R(x,b)]∧[Q(a,y)∨¬Q(y,b)]]"; // ex.3
		//String s = "∃x,y,z[[[[[[[¬R(a1,a2)]∨[¬R(a2,a3)]]∨[¬R(a2,a4)]]∨[¬R(a3,a4)]]∨R(x,y)]∧"
		//		  + "[[[[[¬R(a1,a2)]∨[¬R(a2,a3)]]∨[¬R(a2,a4)]]∨[¬R(a3,a4)]]∨R(x,z)]]∧"
		//		  + "[[[[[¬R(a1,a2)]∨[¬R(a2,a3)]]∨[¬R(a2,a4)]]∨[¬R(a3,a4)]]∨R(y,z)]]"; // ex.4
		//String s = "∃x,y,z[[[[[[[[[[[[¬R(a4,a5)]∨[¬R(a5,a6)]]∨[¬R(a4,a6)]]∨[¬R(a1,a5)]]∨[¬R(a1,a3)]]∨[¬R(a2,a5)]]∨[¬R(a3,a5)]]∨[¬R(a2,a6)]]∨[¬R(a2,a4)]]∨R(x,y)]∧"
		//	       + "[[[[[[[[[[¬R(a4,a5)]∨[¬R(a5,a6)]]∨[¬R(a4,a6)]]∨[¬R(a1,a5)]]∨[¬R(a1,a3)]]∨[¬R(a2,a5)]]∨[¬R(a3,a5)]]∨[¬R(a2,a6)]]∨[¬R(a2,a4)]]∨R(x,z)]]∧"
		//	       + "[[[[[[[[[[¬R(a4,a5)]∨[¬R(a5,a6)]]∨[¬R(a4,a6)]]∨[¬R(a1,a5)]]∨[¬R(a1,a3)]]∨[¬R(a2,a5)]]∨[¬R(a3,a5)]]∨[¬R(a2,a6)]]∨[¬R(a2,a4)]]∨R(y,z)]]"; // ex.5
		
		//String s = "∃x,y,z[[[[[[[[[[[[¬R(a1,a2)]∨[¬R(a2,a3)]]∨[¬R(a1,a3)]]∨[¬R(a3,a4)]]∨[¬R(a3,a5)]]∨[¬R(a3,a6)]]∨[¬R(a1,a4)]]∨[¬R(a1,a5)]]∨[¬R(a1,a6)]]∨R(x,y)]∧"
		//	       + "[[[[[[[[[[¬R(a1,a2)]∨[¬R(a2,a3)]]∨[¬R(a1,a3)]]∨[¬R(a3,a4)]]∨[¬R(a3,a5)]]∨[¬R(a3,a6)]]∨[¬R(a1,a4)]]∨[¬R(a1,a5)]]∨[¬R(a1,a6)]]∨R(x,z)]]∧"
		//	       + "[[[[[[[[[[¬R(a1,a2)]∨[¬R(a2,a3)]]∨[¬R(a1,a3)]]∨[¬R(a3,a4)]]∨[¬R(a3,a5)]]∨[¬R(a3,a6)]]∨[¬R(a1,a4)]]∨[¬R(a1,a5)]]∨[¬R(a1,a6)]]∨R(y,z)]]";

		long start = 0;
		long end = 0;
		long traceTime = 0;
		double sec = 0;
		
		start = System.nanoTime();
				
		mn.cf.quantLit(s);
		String[] p = mn.cf.parameters;									// find parameters
		String[][] razbivka = mn.cf.findRazbivka(s);					// create a razbivka of this formula
		int length = razbivka.length;								// quantity of elements of razbivka (delta)
		
		mn.uni.printRazbivka(razbivka);								// print the razbivka of this formula
		 
		//**********************
		// A-Rule :
		//**********************
		//ra.ruleA(razbivka);										// application of A-Rule, creating & print initial nabors
		
		System.out.println("\n" + "Inference of the formula by INVERSE METHOD:");
		Set<Entry<String, Entry<int[], HashSet<String>>>> set = mn.ra.ruleA(razbivka);     // Set of initial nabors
		nextnumber = set.size()+1;														// set next number of nabors

		//**********************
		// Skleyka-Rule : 					// (for initial nabors)
		//**********************		
		
		Iterator<Entry<String, Entry<int[], HashSet<String>>>> itr = set.iterator(); 
		while (itr.hasNext()) {
			Entry<String, Entry<int[], HashSet<String>>> nabor = itr.next();
			if (mn.skl.isAppSkleyka(nabor)) {
				LinkedHashSet<Entry<String, Entry<int[], HashSet<String>>>> bag = new LinkedHashSet<Entry<String, Entry<int[], HashSet<String>>>>();
				LinkedHashSet<Entry<String, Entry<int[], HashSet<String>>>> sklNabors = mn.skl.ruleSkleyka(nabor, p, nextnumber, bag);
				// Add nabors that resulting after Skleyka to set of nabors 
				Iterator<Entry<String, Entry<int[], HashSet<String>>>> iskl = sklNabors.iterator();
				while (iskl.hasNext()) {
					Entry<String, Entry<int[], HashSet<String>>> sklNabor = iskl.next();
					nextnumber = Integer.parseInt(sklNabor.getKey(), 10) + 1;
					mn.uni.setOfNabors.add(sklNabor);										// Add nabors that reulting after Skleyka to set of nabors 
				}
			}
		}

		mn.ms.createMS(set, length, p.length);
		mn.mSet = mn.ms.mainSet;

		//**********************
		// B-Rule :
		//**********************
		
		//for (int i = 0; i < 1124; i++) {
		
		boolean proved = false;
//		boolean holds = false;
//		int len1 = 0;
//		int len2 = 0;
//		boolean holds2 = false;
//		int length1 = 0;
//		int length2 = 0;
		
		while (proved != true) {
		Iterator<Entry<Double, Set<Entry<String, Entry<String, Entry<int[], HashSet<String>>>>>>> it = mn.mSet.iterator();
		
		Entry<Double, Set<Entry<String, Entry<String, Entry<int[], HashSet<String>>>>>> itis = it.next();
		/*
		// print of number of elem. razbibka
		System.out.print("\n" + itis.getKey() + ". " + "\n");
		// print of nabor
		mn.ms.printSetNab(itis.getValue());*/
		
		Entry<String, Entry<int[], HashSet<String>>> newNabor = mn.rb.ruleB(itis, p, nextnumber);	
			if (newNabor.getValue().getKey().length == 0 && newNabor.getValue().getValue().isEmpty()) {
				System.out.print("\n" + "Q.E.D." + "\n");	
				proved = true;
				break;
			} else if (Integer.parseInt(newNabor.getKey(), 10) < nextnumber) {
				// delete this 
				mn.ms.delElem(itis.getKey());
				//System.out.print("\n" + "Deleted one nabor!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!" + "\n");						
			} else {
				nextnumber++;
				mn.ms.incrIndex(itis.getKey());
				
		/*		holds = false;
				len1 = newNabor.getValue().getKey().length;
				for (Entry<String, Entry<int[], HashSet<String>>> e : mn.uni.setOfNabors) {
					if (holds != true) {
						len2 = e.getValue().getKey().length;
						if (len1 == len2) {
							for (int k = 0; k < len1; k++) {
								if (e.getValue().getKey()[k] == newNabor.getValue().getKey()[k]) {
									if (mn.rb.isEqual(e.getValue().getValue(), newNabor.getValue().getValue())) {
										holds = true; // nabor holds yet
										break;
									}
								}
							}
						}
					} else {break;}
				}
				if (holds != true) {
					mn.uni.setOfNabors.add(newNabor);
					mn.ms.updateMS(newNabor, length, p.length);
				}	*/
				mn.ms.updateMS(newNabor, length, p.length);
				
				//**********************
				// Skleyka-Rule : 					// (for initial nabors)
				//**********************

				if (mn.skl.isAppSkleyka(newNabor)) {
					LinkedHashSet<Entry<String, Entry<int[], HashSet<String>>>> bag = new LinkedHashSet<Entry<String, Entry<int[], HashSet<String>>>>();
					LinkedHashSet<Entry<String, Entry<int[], HashSet<String>>>> sklNabors = mn.skl.ruleSkleyka(newNabor, p, nextnumber, bag);
					if (!sklNabors.isEmpty()) {
						mn.ms.delElem(itis.getKey());
						// Add nabors that reulting after Skleyka to set of nabors 
						Iterator<Entry<String, Entry<int[], HashSet<String>>>> iskl = sklNabors.iterator();
						while (iskl.hasNext()) {
							Entry<String, Entry<int[], HashSet<String>>> sklNabor = iskl.next();
							nextnumber = Integer.parseInt(sklNabor.getKey(), 10) + 1;
							
						/*	holds2 = false;
							length1 = sklNabor.getValue().getKey().length;
							for (Entry<String, Entry<int[], HashSet<String>>> e : mn.uni.setOfNabors) {
								if (holds2 != true) {	
								length2 = e.getValue().getKey().length;
								if (length1 == length2) {
									for (int k = 0; k < len1; k++) {
										if (e.getValue().getKey()[k] == sklNabor.getValue().getKey()[k]) {
											if (mn.rb.isEqual(e.getValue().getValue(), sklNabor.getValue().getValue())) {
												holds2 = true; // nabor holds yet
												break;
											}
										}
									}
								}
								} else {break;}
							}
							if (holds2 != true) {
								mn.uni.setOfNabors.add(sklNabor);
								mn.ms.updateMS(sklNabor, length, p.length);
							}*/
							mn.ms.updateMS(sklNabor, length, p.length);
						}
					}
				}	
			}
		}
			end = System.nanoTime();
			traceTime = end-start;
			sec = traceTime/1000000000;
			System.out.println(sec + " sec. ");
	}	

}




  		